diff -ruNp linux-2.6.34.5/arch/x86/ia32/ia32_aout.c linux-2.6.34.5-cher1/arch/x86/ia32/ia32_aout.c
--- linux-2.6.34.5/arch/x86/ia32/ia32_aout.c	2010-08-20 22:52:05.000000000 +0400
+++ linux-2.6.34.5-cher1/arch/x86/ia32/ia32_aout.c	2010-08-26 14:45:12.198043213 +0400
@@ -299,8 +299,12 @@ static int load_aout_binary(struct linux
 	rlim = rlimit(RLIMIT_DATA);
 	if (rlim >= RLIM_INFINITY)
 		rlim = ~0;
-	if (ex.a_data + ex.a_bss > rlim)
+	if (ex.a_data + ex.a_bss > rlim) {
+		if ((current->sbox_flags & SBOX_MEMLIMITON)) {
+			current->sbox_flags |= SBOX_WAS_MEMLIMIT;
+		}
 		return -ENOMEM;
+	}
 
 	/* Flush all traces of the currently running executable */
 	retval = flush_old_exec(bprm);
diff -ruNp linux-2.6.34.5/arch/x86/ia32/ia32_signal.c linux-2.6.34.5-cher1/arch/x86/ia32/ia32_signal.c
--- linux-2.6.34.5/arch/x86/ia32/ia32_signal.c	2010-08-20 22:52:05.000000000 +0400
+++ linux-2.6.34.5-cher1/arch/x86/ia32/ia32_signal.c	2010-08-26 14:45:12.198562841 +0400
@@ -127,6 +127,9 @@ int copy_siginfo_from_user32(siginfo_t *
 
 asmlinkage long sys32_sigsuspend(int history0, int history1, old_sigset_t mask)
 {
+	if (SBOX_IS_RESTRICTED())
+		return -EPERM;
+
 	mask &= _BLOCKABLE;
 	spin_lock_irq(&current->sighand->siglock);
 	current->saved_sigmask = current->blocked;
@@ -148,6 +151,9 @@ asmlinkage long sys32_sigaltstack(const 
 	int ret, err = 0;
 	mm_segment_t seg;
 
+        if (SBOX_IS_RESTRICTED())
+		return -EPERM;
+
 	if (uss_ptr) {
 		u32 ptr;
 
diff -ruNp linux-2.6.34.5/arch/x86/ia32/ipc32.c linux-2.6.34.5-cher1/arch/x86/ia32/ipc32.c
--- linux-2.6.34.5/arch/x86/ia32/ipc32.c	2010-08-20 22:52:05.000000000 +0400
+++ linux-2.6.34.5-cher1/arch/x86/ia32/ipc32.c	2010-08-26 14:45:12.205562524 +0400
@@ -15,6 +15,11 @@ asmlinkage long sys32_ipc(u32 call, int 
 {
 	int version;
 
+        if (SBOX_IS_RESTRICTED()) {
+		SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	version = call >> 16; /* hack for backward compatibility */
 	call &= 0xffff;
 
diff -ruNp linux-2.6.34.5/arch/x86/ia32/sys_ia32.c linux-2.6.34.5-cher1/arch/x86/ia32/sys_ia32.c
--- linux-2.6.34.5/arch/x86/ia32/sys_ia32.c	2010-08-20 22:52:05.000000000 +0400
+++ linux-2.6.34.5-cher1/arch/x86/ia32/sys_ia32.c	2010-08-26 14:45:12.205562524 +0400
@@ -100,7 +100,12 @@ asmlinkage long sys32_stat64(char __user
 			     struct stat64 __user *statbuf)
 {
 	struct kstat stat;
-	int ret = vfs_stat(filename, &stat);
+        int ret;
+
+        if (SBOX_IS_RESTRICTED())
+        	return -EPERM;
+
+        ret = vfs_stat(filename, &stat);
 
 	if (!ret)
 		ret = cp_stat64(statbuf, &stat);
@@ -111,7 +116,13 @@ asmlinkage long sys32_lstat64(char __use
 			      struct stat64 __user *statbuf)
 {
 	struct kstat stat;
-	int ret = vfs_lstat(filename, &stat);
+	int ret;
+
+        if (SBOX_IS_RESTRICTED())
+		return -EPERM;
+
+        ret = vfs_lstat(filename, &stat);
+
 	if (!ret)
 		ret = cp_stat64(statbuf, &stat);
 	return ret;
@@ -120,7 +131,13 @@ asmlinkage long sys32_lstat64(char __use
 asmlinkage long sys32_fstat64(unsigned int fd, struct stat64 __user *statbuf)
 {
 	struct kstat stat;
-	int ret = vfs_fstat(fd, &stat);
+	int ret;
+
+        if (SBOX_IS_RESTRICTED())
+		return -EPERM;
+
+        ret = vfs_fstat(fd, &stat);
+
 	if (!ret)
 		ret = cp_stat64(statbuf, &stat);
 	return ret;
@@ -132,6 +149,9 @@ asmlinkage long sys32_fstatat(unsigned i
 	struct kstat stat;
 	int error;
 
+        if (SBOX_IS_RESTRICTED())
+		return -EPERM;
+
 	error = vfs_fstatat(dfd, filename, &stat, flag);
 	if (error)
 		return error;
@@ -181,6 +201,11 @@ asmlinkage long sys32_rt_sigaction(int s
 	int ret;
 	compat_sigset_t set32;
 
+        if (SBOX_IS_RESTRICTED()) {
+        	if (sig == SIGTERM || sig == SIGINT)
+                	return -EPERM;
+        }
+
 	/* XXX: Don't preclude handling different sized sigset_t's.  */
 	if (sigsetsize != sizeof(compat_sigset_t))
 		return -EINVAL;
@@ -255,6 +280,9 @@ asmlinkage long sys32_sigaction(int sig,
 	struct k_sigaction new_ka, old_ka;
 	int ret;
 
+        if (SBOX_IS_RESTRICTED())
+		return -EPERM;
+
 	if (act) {
 		compat_old_sigset_t mask;
 		compat_uptr_t handler, restorer;
@@ -295,7 +323,12 @@ asmlinkage long sys32_rt_sigprocmask(int
 	sigset_t s;
 	compat_sigset_t s32;
 	int ret;
-	mm_segment_t old_fs = get_fs();
+	mm_segment_t old_fs;
+
+        if (SBOX_IS_RESTRICTED())
+        	return -EPERM;
+
+	old_fs = get_fs();
 
 	if (set) {
 		if (copy_from_user(&s32, set, sizeof(compat_sigset_t)))
@@ -330,6 +363,9 @@ asmlinkage long sys32_rt_sigprocmask(int
 
 asmlinkage long sys32_alarm(unsigned int seconds)
 {
+        if (SBOX_IS_RESTRICTED())
+		return -EPERM;
+
 	return alarm_setitimer(seconds);
 }
 
@@ -367,7 +403,12 @@ asmlinkage long sys32_rt_sigpending(comp
 	sigset_t s;
 	compat_sigset_t s32;
 	int ret;
-	mm_segment_t old_fs = get_fs();
+	mm_segment_t old_fs;
+
+        if (SBOX_IS_RESTRICTED())
+        	return -EPERM;
+
+	old_fs = get_fs();
 
 	set_fs(KERNEL_DS);
 	ret = sys_rt_sigpending((sigset_t __user *)&s, sigsetsize);
@@ -390,7 +431,12 @@ asmlinkage long sys32_rt_sigqueueinfo(in
 {
 	siginfo_t info;
 	int ret;
-	mm_segment_t old_fs = get_fs();
+	mm_segment_t old_fs;
+
+        if (SBOX_IS_RESTRICTED())
+		return -EPERM;
+
+        old_fs = get_fs();
 
 	if (copy_siginfo_from_user32(&info, uinfo))
 		return -EFAULT;
@@ -420,6 +466,9 @@ asmlinkage long sys32_personality(unsign
 {
 	int ret;
 
+        if (SBOX_IS_RESTRICTED())
+        	personality = current->personality;
+
 	if (personality(current->personality) == PER_LINUX32 &&
 		personality == PER_LINUX)
 		personality = PER_LINUX32;
@@ -432,10 +481,15 @@ asmlinkage long sys32_personality(unsign
 asmlinkage long sys32_sendfile(int out_fd, int in_fd,
 			       compat_off_t __user *offset, s32 count)
 {
-	mm_segment_t old_fs = get_fs();
+	mm_segment_t old_fs;
 	int ret;
 	off_t of;
 
+        if (SBOX_IS_RESTRICTED())
+        	return -EPERM;
+
+	old_fs = get_fs();
+
 	if (offset && get_user(of, offset))
 		return -EFAULT;
 
@@ -455,11 +509,20 @@ asmlinkage long sys32_execve(char __user
 	long error;
 	char *filename;
 
+        if ((current->sbox_flags & SBOX_NO_EXEC)) {
+		SBOX_SET_SECURITY_ERR();
+		return -EPERM;
+        }
+
 	filename = getname(name);
 	error = PTR_ERR(filename);
 	if (IS_ERR(filename))
 		return error;
 	error = compat_do_execve(filename, argv, envp, regs);
+        if (!error) {
+        	if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+			current->sbox_flags |= SBOX_NO_EXEC;
+        }
 	putname(filename);
 	return error;
 }
@@ -503,6 +566,11 @@ long sys32_vm86_warning(void)
 	struct task_struct *me = current;
 	static char lastcomm[sizeof(me->comm)];
 
+        if (SBOX_IS_RESTRICTED()) {
+		SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+	}
+
 	if (strncmp(lastcomm, me->comm, sizeof(lastcomm))) {
 		compat_printk(KERN_INFO
 			      "%s: vm86 mode not supported on 64 bit kernel\n",
diff -ruNp linux-2.6.34.5/arch/x86/kernel/ioport.c linux-2.6.34.5-cher1/arch/x86/kernel/ioport.c
--- linux-2.6.34.5/arch/x86/kernel/ioport.c	2010-08-20 22:52:05.000000000 +0400
+++ linux-2.6.34.5-cher1/arch/x86/kernel/ioport.c	2010-08-26 14:45:12.214567916 +0400
@@ -39,6 +39,11 @@ asmlinkage long sys_ioperm(unsigned long
 	struct tss_struct *tss;
 	unsigned int i, max_long, bytes, bytes_updated;
 
+        if (SBOX_IS_RESTRICTED()) {
+		SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+	}
+
 	if ((from + num <= from) || (from + num > IO_BITMAP_BITS))
 		return -EINVAL;
 	if (turn_on && !capable(CAP_SYS_RAWIO))
@@ -108,6 +113,11 @@ long sys_iopl(unsigned int level, struct
 	unsigned int old = (regs->flags >> 12) & 3;
 	struct thread_struct *t = &current->thread;
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+	}
+
 	if (level > 3)
 		return -EINVAL;
 	/* Trying to gain more privileges? */
diff -ruNp linux-2.6.34.5/arch/x86/kernel/ldt.c linux-2.6.34.5-cher1/arch/x86/kernel/ldt.c
--- linux-2.6.34.5/arch/x86/kernel/ldt.c	2010-08-20 22:52:05.000000000 +0400
+++ linux-2.6.34.5-cher1/arch/x86/kernel/ldt.c	2010-08-26 14:45:12.214567916 +0400
@@ -250,6 +250,11 @@ asmlinkage int sys_modify_ldt(int func, 
 {
 	int ret = -ENOSYS;
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	switch (func) {
 	case 0:
 		ret = read_ldt(ptr, bytecount);
diff -ruNp linux-2.6.34.5/arch/x86/kernel/process.c linux-2.6.34.5-cher1/arch/x86/kernel/process.c
--- linux-2.6.34.5/arch/x86/kernel/process.c	2010-08-20 22:52:05.000000000 +0400
+++ linux-2.6.34.5-cher1/arch/x86/kernel/process.c	2010-08-26 14:45:12.225557177 +0400
@@ -306,12 +306,22 @@ long sys_execve(char __user *name, char 
 	long error;
 	char *filename;
 
+        if ((current->sbox_flags & SBOX_NO_EXEC)) {
+		SBOX_SET_SECURITY_ERR();
+		return -EPERM;
+	}
+
 	filename = getname(name);
 	error = PTR_ERR(filename);
 	if (IS_ERR(filename))
 		return error;
 	error = do_execve(filename, argv, envp, regs);
 
+        if (error == 0) {
+		if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                	current->sbox_flags |= SBOX_NO_EXEC;
+	}
+
 #ifdef CONFIG_X86_32
 	if (error == 0) {
 		/* Make sure we don't return using sysenter.. */
diff -ruNp linux-2.6.34.5/arch/x86/kernel/signal.c linux-2.6.34.5-cher1/arch/x86/kernel/signal.c
--- linux-2.6.34.5/arch/x86/kernel/signal.c	2010-08-20 22:52:05.000000000 +0400
+++ linux-2.6.34.5-cher1/arch/x86/kernel/signal.c	2010-08-26 14:45:12.225557177 +0400
@@ -485,6 +485,9 @@ static int __setup_rt_frame(int sig, str
 asmlinkage int
 sys_sigsuspend(int history0, int history1, old_sigset_t mask)
 {
+        if (SBOX_IS_RESTRICTED())
+        	return -EPERM;
+
 	mask &= _BLOCKABLE;
 	spin_lock_irq(&current->sighand->siglock);
 	current->saved_sigmask = current->blocked;
@@ -506,6 +509,9 @@ sys_sigaction(int sig, const struct old_
 	struct k_sigaction new_ka, old_ka;
 	int ret = 0;
 
+        if (SBOX_IS_RESTRICTED())
+		return -EPERM;
+
 	if (act) {
 		old_sigset_t mask;
 
@@ -549,6 +555,9 @@ long
 sys_sigaltstack(const stack_t __user *uss, stack_t __user *uoss,
 		struct pt_regs *regs)
 {
+        if (SBOX_IS_RESTRICTED())
+		return -EPERM;
+
 	return do_sigaltstack(uss, uoss, regs->sp);
 }
 
diff -ruNp linux-2.6.34.5/arch/x86/kernel/vm86_32.c linux-2.6.34.5-cher1/arch/x86/kernel/vm86_32.c
--- linux-2.6.34.5/arch/x86/kernel/vm86_32.c	2010-08-20 22:52:05.000000000 +0400
+++ linux-2.6.34.5-cher1/arch/x86/kernel/vm86_32.c	2010-08-26 14:45:12.228703714 +0400
@@ -207,6 +207,11 @@ int sys_vm86old(struct vm86_struct __use
 	struct task_struct *tsk;
 	int tmp, ret = -EPERM;
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	tsk = current;
 	if (tsk->thread.saved_sp0)
 		goto out;
@@ -237,6 +242,11 @@ int sys_vm86(unsigned long cmd, unsigned
 	int tmp, ret;
 	struct vm86plus_struct __user *v86;
 
+        if (SBOX_IS_RESTRICTED()) {
+        	SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+	}
+
 	tsk = current;
 	switch (cmd) {
 	case VM86_REQUEST_IRQ:
diff -ruNp linux-2.6.34.5/arch/x86/SYSCALLS.i386 linux-2.6.34.5-cher1/arch/x86/SYSCALLS.i386
--- linux-2.6.34.5/arch/x86/SYSCALLS.i386	1970-01-01 03:00:00.000000000 +0300
+++ linux-2.6.34.5-cher1/arch/x86/SYSCALLS.i386	2010-08-26 14:45:12.229578698 +0400
@@ -0,0 +1,346 @@
+sys_exit
+ptregs_fork			
+sys_read
+sys_write
+sys_open			
+sys_close
+sys_waitpid			
+sys_creat			
+sys_link
+sys_unlink
+ptregs_execve
+sys_chdir
+sys_time
+sys_mknod
+sys_chmod
+sys_lchown16
+sys_ni_syscall
+sys_stat
+sys_lseek
+sys_getpid
+sys_mount
+sys_oldumount
+sys_setuid16
+sys_getuid16
+sys_stime
+sys_ptrace
+sys_alarm
+sys_fstat
+sys_pause
+sys_utime
+sys_ni_syscall
+sys_ni_syscall
+sys_access
+sys_nice
+sys_ni_syscall
+sys_sync
+sys_kill
+sys_rename
+sys_mkdir
+sys_rmdir
+sys_dup
+sys_pipe
+sys_times
+sys_ni_syscall
+sys_brk
+sys_setgid16
+sys_getgid16
+sys_signal
+sys_geteuid16
+sys_getegid16
+sys_acct
+sys_umount
+sys_ni_syscall
+sys_ioctl
+sys_fcntl
+sys_ni_syscall
+sys_setpgid
+sys_ni_syscall
+sys_olduname
+sys_umask
+sys_chroot
+sys_ustat
+sys_dup2
+sys_getppid
+sys_getpgrp
+sys_setsid
+sys_sigaction
+sys_sgetmask
+sys_ssetmask
+sys_setreuid16
+sys_setregid16
+sys_sigsuspend
+sys_sigpending
+sys_sethostname
+sys_setrlimit
+sys_old_getrlimit
+sys_getrusage
+sys_gettimeofday
+sys_settimeofday
+sys_getgroups16
+sys_setgroups16
+old_select
+sys_symlink
+sys_lstat
+sys_readlink
+sys_uselib
+sys_swapon
+sys_reboot
+sys_old_readdir
+old_mmap
+sys_munmap
+sys_truncate
+sys_ftruncate
+sys_fchmod
+sys_fchown16
+sys_getpriority
+sys_setpriority
+sys_ni_syscall
+sys_statfs
+sys_fstatfs
+sys_ioperm
+sys_socketcall
+sys_syslog
+sys_setitimer
+sys_getitimer
+sys_newstat
+sys_newlstat
+sys_newfstat
+sys_uname
+ptregs_iopl
+sys_vhangup
+sys_ni_syscall
+ptregs_vm86old
+sys_wait4
+sys_swapoff
+sys_sysinfo
+sys_ipc
+sys_fsync
+ptregs_sigreturn
+ptregs_clone
+sys_setdomainname
+sys_newuname
+sys_modify_ldt
+sys_adjtimex
+sys_mprotect
+sys_sigprocmask
+sys_ni_syscall
+sys_init_module
+sys_delete_module
+sys_ni_syscall
+sys_quotactl
+sys_getpgid
+sys_fchdir
+sys_bdflush
+sys_sysfs
+sys_personality
+sys_ni_syscall
+sys_setfsuid16
+sys_setfsgid16
+sys_llseek
+sys_getdents
+sys_select
+sys_flock
+sys_msync
+sys_readv
+sys_writev
+sys_getsid
+sys_fdatasync
+sys_sysctl
+sys_mlock
+sys_munlock
+sys_mlockall
+sys_munlockall
+sys_sched_setparam
+sys_sched_getparam
+sys_sched_setscheduler
+sys_sched_getscheduler
+sys_sched_yield
+sys_sched_get_priority_max
+sys_sched_get_priority_min
+sys_sched_rr_get_interval
+sys_nanosleep
+sys_mremap
+sys_setresuid16
+sys_getresuid16
+ptregs_vm86
+sys_ni_syscall
+sys_poll
+sys_nfsservctl
+sys_setresgid16
+sys_getresgid16
+sys_prctl
+ptregs_rt_sigreturn
+sys_rt_sigaction
+sys_rt_sigprocmask
+sys_rt_sigpending
+sys_rt_sigtimedwait
+sys_rt_sigqueueinfo
+sys_rt_sigsuspend
+sys_pread64
+sys_pwrite64
+sys_chown16
+sys_getcwd
+sys_capget
+sys_capset
+ptregs_sigaltstack
+sys_sendfile
+sys_ni_syscall
+sys_ni_syscall
+ptregs_vfork
+sys_getrlimit
+sys_mmap2
+sys_truncate64
+sys_ftruncate64
+sys_stat64
+sys_lstat64
+sys_fstat64
+sys_lchown
+sys_getuid
+sys_getgid
+sys_geteuid
+sys_getegid
+sys_setreuid
+sys_setregid
+sys_getgroups
+sys_setgroups
+sys_fchown
+sys_setresuid
+sys_getresuid
+sys_setresgid
+sys_getresgid
+sys_chown
+sys_setuid
+sys_setgid
+sys_setfsuid
+sys_setfsgid
+sys_pivot_root
+sys_mincore
+sys_madvise
+sys_getdents64
+sys_fcntl64
+sys_ni_syscall
+sys_ni_syscall
+sys_gettid
+sys_readahead
+sys_setxattr
+sys_lsetxattr
+sys_fsetxattr
+sys_getxattr
+sys_lgetxattr
+sys_fgetxattr
+sys_listxattr
+sys_llistxattr
+sys_flistxattr
+sys_removexattr
+sys_lremovexattr
+sys_fremovexattr
+sys_tkill
+sys_sendfile64
+sys_futex
+sys_sched_setaffinity
+sys_sched_getaffinity
+sys_set_thread_area
+sys_get_thread_area
+sys_io_setup
+sys_io_destroy
+sys_io_getevents
+sys_io_submit
+sys_io_cancel
+sys_fadvise64
+sys_ni_syscall
+sys_exit_group
+sys_lookup_dcookie
+sys_epoll_create
+sys_epoll_ctl
+sys_epoll_wait
+sys_remap_file_pages
+sys_set_tid_address
+sys_timer_create
+sys_timer_settime
+sys_timer_gettime
+sys_timer_getoverrun
+sys_timer_delete
+sys_clock_settime
+sys_clock_gettime
+sys_clock_getres
+sys_clock_nanosleep
+sys_statfs64
+sys_fstatfs64
+sys_tgkill
+sys_utimes
+sys_fadvise64_64
+sys_ni_syscall
+sys_mbind
+sys_get_mempolicy
+sys_set_mempolicy
+sys_mq_open
+sys_mq_unlink
+sys_mq_timedsend
+sys_mq_timedreceive
+sys_mq_notify
+sys_mq_getsetattr
+sys_kexec_load
+sys_waitid
+sys_ni_syscall
+sys_add_key
+sys_request_key
+sys_keyctl
+sys_ioprio_set
+sys_ioprio_get
+sys_inotify_init
+sys_inotify_add_watch
+sys_inotify_rm_watch
+sys_migrate_pages
+sys_openat
+sys_mkdirat
+sys_mknodat
+sys_fchownat
+sys_futimesat
+sys_fstatat64
+sys_unlinkat
+sys_renameat
+sys_linkat
+sys_symlinkat
+sys_readlinkat
+sys_fchmodat
+sys_faccessat
+sys_pselect6
+sys_ppoll
+sys_unshare
+sys_set_robust_list
+sys_get_robust_list
+sys_splice
+sys_sync_file_range
+sys_tee
+sys_vmsplice
+sys_move_pages
+sys_getcpu
+sys_epoll_pwait
+sys_utimensat
+sys_signalfd
+sys_timerfd_create
+sys_eventfd
+sys_fallocate
+sys_timerfd_settime
+sys_timerfd_gettime
+sys_signalfd4
+sys_eventfd2
+sys_epoll_create1
+sys_dup3
+sys_pipe2
+sys_inotify_init1
+sys_preadv
+sys_pwritev
+sys_rt_tgsigqueueinfo
+sys_perf_event_open
+sys_recvmmsg
+
+Syscall_0:
+sys_restart_syscall
+
+=== END OF SYSCALL TABLE ===
+*) The line number corresponds to syscall number
+**) sys_fork, sys_vfork, sys_clone -> do_fork (kernel/fork.c)
+
+syscall table in arch/x86/kernel/syscall_table_32.S
